/********************************** (C) COPYRIGHT *******************************
* File Name          : Timer1.C
* Author             : WCH
* Version            : V1.3
* Date               : 2016/06/24
* Description        : CH559 TIME1ӿں                				   
*******************************************************************************/

#include "..\DEBUG.C"                                                          //Ϣӡ
#include "..\DEBUG.H"

#pragma  NOAREGS

//CH559 Timer1ʱѡ   
//bTMR_CLKͬʱӰTimer0&1&2,ʹʱҪע                                                       
#define mTimer1ClkFsys( ) (T2MOD |= bTMR_CLK | bT1_CLK)                     //ʱ,ʱ=Fsys
#define mTimer1Clk4DivFsys( ) (T2MOD &= ~bTMR_CLK;T2MOD |=  bT1_CLK)        //ʱ,ʱ=Fsys/4
#define mTimer1Clk12DivFsys( ) (T2MOD &= ~(bTMR_CLK | bT1_CLK))             //ʱ,ʱ=Fsys/12
#define mTimer1CountClk( ) (TMOD |= bT1_CT)                                 //,T1ŵ½Ч

//CH559 Timer1 ʼ(SS=1)/(SS=0)
#define mTimer1RunCTL( SS ) (TR1 = SS ? START : STOP)

/*******************************************************************************
* Function Name  : mTimer1ModSetup(UINT8 mode)
* Description    : CH559ʱ1ģʽ
* Input          : UINT8 mode,Timer1ģʽѡ
                   0ģʽ013λʱTL1ĸ3λЧ
                   1ģʽ116λʱ
                   2ģʽ28λԶװʱ
                   3ģʽ3ֹͣTimer1
* Output         : None
* Return         : None
*******************************************************************************/
void mTimer1ModSetup(UINT8 mode)
{
    TMOD &= 0x0f;
    TMOD |= mode << 4; 
}

/*******************************************************************************
* Function Name  : mTimer1SetData(UINT16 dat)
* Description    : CH559Timer1 TH1TL1ֵ
* Input          : UINT16 dat;ʱֵ
* Output         : None
* Return         : None
*******************************************************************************/
void mTimer1SetData(UINT16 dat)
{
  UINT16 tmp;
  tmp = 65536 - dat;
	TL1 = tmp & 0xff;
	TH1 = (tmp>>8) & 0xff;
}

/*******************************************************************************
* Function Name  : mTimer1Interrupt()
* Description    : CH559ʱ1ʱжϴ
*******************************************************************************/
void	mTimer1Interrupt( void ) interrupt INT_NO_TMR1 using 1                   //timer1жϷ,ʹüĴ1
{                                                                            //ʽ3ʱֹͣTimer1
	mInitSTDIO( );
	printf("stop ...\n");
	while(1);
                                                 //Զطʽ¸TH1TL1ֵ        
}

main( ) 
{
	UINT8 a,b,c;
//  CfgFsys( );                                                                //CH559ʱѡ 
    mDelaymS(5);                                                               //ȴⲿȶ
    mInitSTDIO( );                                                             //0,ڵ
    printf("start ...\n");

    mTimer1Clk12DivFsys( );                                                    //ʱѡFsysʱʽ
    mTimer1ModSetup(2);	                                                       //ʽ2Զ8Ϊʱ                                                      
    mTimer1SetData(30536);     //12Msys+12div=35ms                                               //ʱֵ
    mTimer1RunCTL(1);                                                          //ʱ

	ET1 = 1;                                                                   //ʹܶʱ1ж
    EA = 1;                                                                    //ʹȫж
	    
    while(1);
}

